#ifndef MYTHTUBE_H
#define MYTHTUBE_H

#include <mythtv/libmythui/mythscreentype.h>
#include <mythtv/libmythui/mythuitext.h>
#include <mythtv/libmythui/mythuitextedit.h>
#include <mythtv/libmythui/mythlistbutton.h>
#include <mythtv/libmythui/mythuiimage.h>
#include <mythtv/libmythui/mythdialogbox.h>
#include <mythtv/libmythui/mythprogressdialog.h>
#include <mythtv/httpcomms.h>

#include <qstring.h>

#include "tubevideo.h"

class MythTube : public MythScreenType
{

Q_OBJECT

public:

    MythTube(MythScreenStack *parent, const char *name);
    ~MythTube();

    bool Create();
    bool keyPressEvent(QKeyEvent *event);

private:

    //GUI elements
    MythUITextEdit *m_queryEdit;
    MythUIButton *m_searchButton;
    MythListButton *m_videoList;
    MythUIText *m_infoText;
    MythUIImage *m_thumbnailImage;

    //Download video elements
    HttpComms      *httpGrabber;
    bool           abortHttp;
    MythUIProgressDialog *m_progressPopup;

    //Private functions
    void createProgress(QString title);
    bool getHttpFile(QString sFilename, QString cmdURL);
    void playVideo(const QString &filename);

// signals:
//     void finished(MythTube* item);

private slots:

    void slotSearch(void);
    void showResult(Search* search);
    void updateInfoView(MythListButtonItem* selected);
    void slotViewVideo(MythListButtonItem* selected);

};


#endif
